
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>浅析JavaScript原型继承的陷阱 / iVAN</title>

    <meta name="description" content="浅析JavaScript原型继承的陷阱  JavaScript和其它面向对象语言一样,对象类型采用引用方式.持有对象的变量只是一个地址,而基本类型数据是值.当原型上存储对象时,就可能有一些陷阱 JavaScript默认采用原型继承.虽然没有类(class)的概念,它的函数(function)可以充当构造器(constructor).构造器结合this,new可以构建出类似Java的类.因此,JavaScript通过扩展自身能模拟类式(class-based)继承.   JavaScript和其它面向对象语言一样,对象类型采用引用方式.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">浅析JavaScript原型继承的陷阱</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p> JavaScript和其它面向对象语言一样，对象类型采用引用方式。持有对象的变量只是一个地址，而基本类型数据是值。当原型上存储对象时，就可能有一些陷阱</p>
<p>JavaScript默认采用原型继承。虽然没有类(class)的概念，它的函数(function)可以充当构造器(constructor)。构造器结合this，new可以构建出类似Java的类。因此，JavaScript通过扩展自身能模拟类式(class-based)继承。<br />
 <br />
JavaScript和其它面向对象语言一样，对象类型采用引用方式。持有对象的变量只是一个地址，而基本类型数据是值。当原型上存储对象时，就可能有一些陷阱。<br />
 <br />
先看第一个例子<br />
 <br />
 <br />
代码如下:<br />
var create = function() { <br />
    function Fn() {} <br />
    return function(parent) { <br />
        Fn.prototype = parent <br />
        return new Fn <br />
    } <br />
}() <br />
 <br />
var parent = { <br />
    name: 'jack', <br />
    age: 30, <br />
    isMarried: false<br />
} <br />
var child = create(parent) <br />
console.log(child) <br />
 <br />
create工具函数实现了一个基本的原型继承，每次调用create都会根据parent对象去复制一个新对象，新对象全部的属性都来自于parent。这里parent有三个属性，都是基本数据类型：字符串，数字，布尔。<br />
 <br />
这时修改child看看会不会影响parent<br />
 <br />
 <br />
代码如下:<br />
child.name = 'lily'<br />
child.age = 20, <br />
child.isMarried = true<br />
 <br />
console.log(child) <br />
console.log(parent) <br />
 <br />
 <br />
结果如下<br />
 <br />
 <br />
 <br />
即修改child不会影响到parent。<br />
 <br />
再看看另外一个例子<br />
 <br />
 <br />
代码如下:<br />
var create = function() { <br />
    function Fn() {} <br />
    return function(parent) { <br />
        Fn.prototype = parent <br />
        return new Fn <br />
    } <br />
}() <br />
 <br />
var parent = { <br />
    data: { <br />
        name: 'jack', <br />
        age: 30, <br />
        isMarried: false<br />
    }, <br />
    language: ['Java'] <br />
} <br />
var child = create(parent) <br />
 <br />
child.data.name = 'lily'<br />
child.data.age = 20 <br />
child.data.isMarried = true<br />
child.language.push('javascript') <br />
console.dir(child) <br />
console.dir(parent)<br />
 <br />
注意这里的parent的两个属性data，language都是引用类型，一个是对象，一个是数组。child仍然继承与parent，随后修改了child，结果如下<br />
 <br />
 <br />
 <br />
可以看到，此时parent也被修改了，和child的name，age等都一样了。这是使用原型继承时需要注意的。<br />
 <br />
使用继承时比较好的方式是：<br />
 <br />
1，数据属性采用类式继承（挂在this上），这样new时也可以通过参数配置<br />
 <br />
2，方法采用原型继承，这样能节省内存，同时子类重写方法也不会影响父类<br />
 <br />
下面是一个满足以上2点的写类工具函数<br />
 <br />
 <br />
代码如下:<br />
/** <br />
 * @param {String} className <br />
 * @param {String/Function} superCls <br />
 * @param {Function} factory <br />
 */<br />
function $class(name, superClass, factory) { <br />
    if (superClass === '') superClass = Object <br />
    function clazz() { <br />
        if (typeof this.init === 'function') { <br />
            this.init.apply(this, arguments) <br />
        } <br />
    } <br />
    var p = clazz.prototype = new superCls <br />
    clazz.prototype.constructor = clazz <br />
    clazz.prototype.className = className <br />
    var supr = superCls.prototype <br />
    window[className] = clazz <br />
    factory.call(p, supr) <br />
}<br />
 <br />
对象类型放在父类原型上时务必小心子类修改其，这时继承于该父类的所有子类的实例都将被修改。而这造成的bug很不容易发现。<br />
 <br />
ES5中加入了一个新API用来实现原型继承：Object.create。可以用它替代上面自实现的create函数，如下<br />
 <br />
 <br />
代码如下:<br />
var parent = { <br />
    name: 'jack', <br />
    age: 30, <br />
    isMarried: false<br />
} <br />
var child = Object.create(parent) <br />
console.log(child) </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-08 10:34:54</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e5%8e%9f%e5%9e%8b/" title="原型">原型</a>, <a href="https://www.iamivan.net/tag/%e5%af%b9%e8%b1%a1/" title="对象">对象</a>, <a href="https://www.iamivan.net/tag/function/" title="function">function</a>, <a href="https://www.iamivan.net/tag/child/" title="child">child</a>, <a href="https://www.iamivan.net/tag/parent/" title="&num;parent">&num;parent</a>, <a href="https://www.iamivan.net/tag/parents/" title="parents">parents</a>, <a href="https://www.iamivan.net/tag/javascript%e9%99%b7%e9%98%b1/" title="javascript陷阱">javascript陷阱</a>, <a href="https://www.iamivan.net/tag/object-create/" title="Object&period;create">Object&period;create</a>, <a href="https://www.iamivan.net/tag/console-dir-%e5%87%bd%e6%95%b0/" title="console&period;dir&lpar;&rpar;函数">console&period;dir&lpar;&rpar;函数</a>, <a href="https://www.iamivan.net/tag/js%e7%b1%bb%e5%bc%8f%e7%bb%a7%e6%89%bf/" title="js类式继承">js类式继承</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>浅析JavaScript原型继承的陷阱的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgEevEz.html" rel="bookmark">浅析JavaScript原型继承的陷阱&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaScript默认采用原型继承.虽然没有类(class)的概念,它的函数(function)可以充当构造器(constructor).构造器结合this,new可以构建出类似Java的类.因此,JavaScript通过扩展自身能模拟类式(class-based)继承. JavaScript和其它面向对象语言一样,对象类型采用引用方式.持有对象的变量只是一个地址,而基本类型数据是值.当原型上存储对象时,就可能有一些陷阱. 先看第一个例子 复制代码 代码如下: var create = fun			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MyvvKlp.html" rel="bookmark">浅析JS原型继承与类的继承&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们先看JS类的继承 &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;meta charset=&quot;UTF-8&quot;&gt; &lt;title&gt;JS类的继承&lt;/title&gt; &lt;/head&gt; &lt;body&gt; /* -- 类式继承 -- */ &lt;script type=&quot;text/javascript&quot;&gt; //先声明一个超类 var Animal = function			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlRRORz.html" rel="bookmark">javascript原型继承中两种方法的简介和对比</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在实际的项目中,我们通常都是用构造函数来创建一个对象,再将一些常用的方法添加到其原型对象上.最后要么直接实例化该对象,要么将它作为父类,再申明一个对象,继承该父类. 而在继承的时候有两种常用方式,今天我们就来稍作探讨 //父类 function Person(name){ this.name = name; }; // 子类 function Student(sex){ Person.apply(this,arguments); //继承父类的构造函数 this.sex=sex; }; 1,继承			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdmmx1z.html" rel="bookmark">JavaScript 原型继承之构造函数继承&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上回说到&lt;JavaScript 原型继承之基础机制&gt;,这一篇将具体说说构造函数的继承. 从一个简单的示例开始,创建描述人类的 People 构造函数: 复制代码 代码如下: function People(){ this.race = '愚蠢的人类'; } 然后,创建描述黄种人的 Yellow 构造函数: 复制代码 代码如下: function Yellow(name, skin){ this.name = name; this.skin = skin; } 要使得黄种人 Yellow 能继承			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z44LmNz.html" rel="bookmark">javascript原型继承工作原理和实例详解&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				先为大家分享JS原型继承实例,供大家参考,具体内容如下 一.JS原型继承 &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;meta charset=&quot;UTF-8&quot;&gt; &lt;title&gt;JS原型继承&lt;/title&gt; &lt;/head&gt; &lt;body&gt; &lt;!--原型继承--&gt; &lt;script type=&quot;text/javascript&quot;&gt; //cl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvGq41p.html" rel="bookmark">再谈javascript原型继承</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 真正意义上来说Javascript并不是一门面向对象的语言,没有提供传统的继承方式,但是它提供了一种原型继承的方式,利用自身提供的原型属性来实现继承. 原型与原型链 说原型继承之前还是要先说说原型和原型链,毕竟这是实现原型继承的基础. 在Javascript中,每个函数都有一个原型属性prototype指向自身的原型,而由这个函数创建的对象也有一个__proto__属性指向这个原型,而函数的原型是一个对象,所以这个对象也会有一个__proto__指向自己的原型,这样逐层深入直到Object对象			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M027B8z.html" rel="bookmark">JavaScript 原型继承&lowbar;js面向对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Object.prototype JavaScript是基于原型继承的,任何对象都有一个prototype属性.Object.prototype是所有对象的根,并且不可改变. 复制代码 代码如下: Object.prototype=null; alert(Object.prototype);//[object Object] Object与Object.prototype Object继承于Object.prototype,增加一个属性给Object.prototype上,同时也会反应到Obje			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjqyv5z.html" rel="bookmark">再谈javascript原型继承&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				真正意义上来说Javascript并不是一门面向对象的语言,没有提供传统的继承方式,但是它提供了一种原型继承的方式,利用自身提供的原型属性来实现继承. 原型与原型链 说原型继承之前还是要先说说原型和原型链,毕竟这是实现原型继承的基础. 在Javascript中,每个函数都有一个原型属性prototype指向自身的原型,而由这个函数创建的对象也有一个__proto__属性指向这个原型,而函数的原型是一个对象,所以这个对象也会有一个__proto__指向自己的原型,这样逐层深入直到Object对象的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boLD9jM.html" rel="bookmark">JavaScript原型继承之基础机制分析&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这一语言功能的本质依赖于 JavaScript 特有的原型链(prototype chain)模式. 所以严格意义上说,JavaScript 是基于原型的面向对象语言.也就是说,每个实例对象都具有一个原型.对象从该原型中继承属性和方法. 1.构造函数 利用构造函数,可以简单地创建对象.构造函数内的 this 关键字指向实例对象本身: 复制代码 代码如下: function People(name){ this.name = name; } 使用 new 运算符和构造函数创建实例对象: 复制代码			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz720Zp.html" rel="bookmark" class="title">li 前面的缩进怎么去除？</a>
					<div>
						异常处理汇总-前端系列 http://www.cnblogs.com/dunitian/p/4523015.html 设置margin和padding为0或者为比较小的值就可以了					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQwXrp.html" rel="bookmark" class="title">网站基本配色&mdash;&mdash;强烈</a>
					<div>
						配色 最有力的色彩组合是充满刺激的快感和支配的欲念,但总离不开红色:不管颜色是怎么组合,红色绝对是少不了的. 红色是最终力量来源--强烈.大胆.极端. 力量的色彩组合象征人类最激烈的感情:爱.恨.情. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOoKQz.html" rel="bookmark" class="title">用Photoshop给美女的衣服换图饰</a>
					<div>
						最近有个朋友问MM换衣的方法,很多朋友都写了自己的想法,我搜索了一下,又找出疯子的那篇看,我也积累了一些方法,发出来大家看看,请各位前辈朋友指正!!! 做前先观察下,看图! 我这里主要用到滤镜中的置换 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGWB6z.html" rel="bookmark" class="title">SQL数据操作基础&lpar;初级&rpar;3</a>
					<div>
						数据 操作字段 通常,当你从一个表中取出字段值时,该值与创建该表时所定义的字段名联系在一起.如果你从表authors中选择所有的作者名字,所有的值将会与字段名au_lname相联系.但是在某些情况下, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bo4o6M.html" rel="bookmark" class="title">网站设计参考&colon;25个最好的非盈利组织网站设计</a>
					<div>
						25个最佳的非盈利组织网站设计 Sower of Seeds Urban Roots A Word from His Word The Seed Company Wide Awake Park Ang ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5jdnz.html" rel="bookmark" class="title">草根站长分析关键字急剧下滑的原因</a>
					<div>
						国内最大的搜索引擎百度最近又有所调整,许多站点关键字排名都掉了,本人的网站在此次调整中关键字排名也调到了一百名之外.站点关键词排名下滑的原因很多,为了让关键字排名能尽快恢复,本人认真分析了其中的原因, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3NNmAz.html" rel="bookmark" class="title">Ajax无刷新求和运算的简单实例&lpar;&period;net&rpar;</a>
					<div>
						&lt;%@ Page Language=&quot;C#&quot; AutoEventWireup=&quot;true&quot; CodeFile=&quot;SumNumber.aspx.c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKoG5M.html" rel="bookmark" class="title">WCF中的自定义集合</a>
					<div>
						WCF Tips之一 集合元素类的定义如下: public enum FileType { TXT,DOC,HTML,OTHER } [DataContract] public class Docum ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRdE8z.html" rel="bookmark" class="title">深入学习java构造函数</a>
					<div>
						*来自对构造函数的继承,及相关调用思考得到,主要还是从&lt;java面向对象编程&gt;得来 *在多级继承的情况下,将从继承树的最上层的父类开始,依次执行各个类的构造方法, 这可以保证子类对象从所有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwdd4b.html" rel="bookmark" class="title">30个美食餐饮类创意网站设计</a>
					<div>
						  相信所有人都喜欢美食,你会去关注美食的网站吗? 看到这些美食网站会不会一样赏心悦目,让你口水直流忍不住想要品尝一下,这里分享30个美食网站创意设计,无论你是不是设计师都可以从这些网站得到很多视觉享 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42dgYM.html" rel="bookmark" class="title">bmp是什么格式</a>
					<div>
						  BMP(全称Bitmap)是Window操作系统中的标准图像文件格式,可以分成两类:设备相关位图(DDB)和设备无关位图(DIB),使用非常广.它采用位映射存储格式,除了图像深度可选以外,不采用其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WA06b.html" rel="bookmark" class="title">移动3G手机wap网站的一些推广方法</a>
					<div>
						现在3G这么热,不知有哪位站长也在想是不是要应该弄个wap的网站来搞,因为现在做网站的人绝大部分都还是集中在互联网上,很少有人想做3G的.可以预测的是WAP网站在未来的一两年间必定会成为站长们的兵家必 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NLPNM.html" rel="bookmark" class="title">iPad 2大号扬声器新证</a>
					<div>
						昨日有报道称,iPad 2的设计将进行小幅更改,提供更窄的边框和大尺寸外放扬声器.今天,这一消息又得到了侧面印证.在http://www.aliyun.com/zixun/aggregation/29 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2aDEb.html" rel="bookmark" class="title">意译：《JVM Internals》</a>
					<div>
						译者语   为加深对JVM的了解和日后查阅时更方便,于是对原文进行翻译.内容是建立在我对JVM的认识的基础上翻译的,加上本人的英语水平有限,若有纰漏请大家指正,谢谢.   原文地址:http://bl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NjEPM.html" rel="bookmark" class="title">黑盒测试-211小硕，两个offer比较，望大神指点迷津</a>
					<div>
						问题描述 211小硕,两个offer比较,望大神指点迷津 本人今年毕业,211小硕,女生,先收到两个offer,不知如何选择,望大家帮我分析分析 1.上海贝尔(阿尔卡特朗讯),做无线系统测试 2.苏州 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEaGqp.html" rel="bookmark" class="title">ASP&period;NET 实现点击左侧菜单，实现将相应的值传给另一个aspx文件</a>
					<div>
						问题描述 我的程序是基于DWZ框架做的,左侧菜单是在后台中拼接的,我想在onclick事件中实现传值,有人知道怎么做吗?另外我想弱弱的问一下,onclick事件只能执行脚本函数吗?不能执行后台定义的函 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBZRlb.html" rel="bookmark" class="title">【转】打造个性化ghostxp光盘另类教程&lpar;3&rpar;</a>
					<div>
						打造个性化ghostxp光盘另类教程(3) 原创:一年只爱你四天 九.修改工具及其主要作用 1.         软碟通UltraISO,主要是打开iso文件,提取添加所需要文件或光盘引导文件,也可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwW7P5z.html" rel="bookmark" class="title">对Lombok有点好奇。有人解释下原理么</a>
					<div>
						问题描述 使用Lombok的都知道 ,在属性前加入注解@Setter or @Getter后,在eclipse下就能够立马看到getter方法和setter方法,Lombok采用 Annotation ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZkB7z.html" rel="bookmark" class="title">传新闻集团计划今年年中出售MySpace</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 北京时间1月4日消息,据国外媒体报 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWOjkz.html" rel="bookmark" class="title">《Log4j 2官方文档》 Configuration Syntax</a>
					<div>
						配置语法 正如之前的例子所展示的一样,Log4j允许你简单地重新定义记录日志的行为而不需要去修改你的应用.可以禁用应用程序的某些部分的日志记录,只在满足特定标准时记录日志,例如为特定用户执行的操作,路 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Zaj7z.html" rel="bookmark" class="title">先了解自己的培训需求，再寻找合适的课程</a>
					<div>
						专家建议,有意于微营销的人,先了解自己的培训需求,再寻找合适的课程. 继前几年微博营销走红之后,2013年微信营销又成为人们关注的热点.而随着微营销诞生的微营销培训,也在近两年火了一把,各种机构.导师 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKlO0z.html" rel="bookmark" class="title">互联网时代的电商品牌与公关（一）</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 作为多年品牌及公关研究.实践者,笔者从未停止过对品牌运营及公关的思考与实践.当下,以互联网电商趋势为主要代表的互联网经济及即将火爆登场的移动互联时代,将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWNDGM.html" rel="bookmark" class="title">GIS基础软件及操作&lpar;四&rpar;</a>
					<div>
						原文 GIS基础软件及操作(四) 练习四.空间数据处理 1.空间数据处理(融合.合并.剪切.交叉.合并)2.设置地图投影及投影变换 空间数据处理 数据:云南县界.shp; Clip.shp西双版纳森林 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YxDlz.html" rel="bookmark" class="title">openfire-jwchat怎么查询历史记录？</a>
					<div>
						问题描述 jwchat怎么查询历史记录? 在查看jwchat的源码时,发现其实他是有可以查看历史记录的,有个&quot;历史&quot;按键被屏蔽了.我修改显示这个按键后,点击没有任何反应. 请问jw ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjOoWM.html" rel="bookmark" class="title">谷歌表示Chrome OS目标非平板电脑</a>
					<div>
						谷歌表示,Chrome OS的重点是笔记本和台式机,而非瞄准平板http://www.aliyun.com/zixun/aggregation/9397.html&quot;&gt;电脑市场. 当被问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0nlQM.html" rel="bookmark" class="title">新华三下一代计算开启新格局</a>
					<div>
						数字经济已融入到人们工作与生活的每个角落.在数字经济浪潮席卷全球的今天,面对数字化转型趋势下业务需求的复杂性,企业需要更灵活.更动态.随需应变的IT基础设施,其中服务器产品的核心支撑作用首当其冲. 前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBk0k9M.html" rel="bookmark" class="title">CSS Lightbox效果</a>
					<div>
						Close					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6NkJM.html" rel="bookmark" class="title">通用PHP动态生成静态HTML网页的代码&lowbar;php技巧</a>
					<div>
						我们知道,PHP读取MYSQL动态显示,在访问量大的情况下,会有很多性能问题,如果租用别人的虚拟主机,则会因为CPU消耗过多而被限制CPU,导致网页无法访问.我这里给出一个PHP动态生成HTML的方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOnoXxp.html" rel="bookmark" class="title">Excel文档单元格怎么设置字符上标和下标？</a>
					<div>
						和Word不同,Excel的&quot;格式&quot;菜单中没有直接设置字体格式的命令,格式设置存在于&quot;单元格格式&quot;对话框中.单元格中上下标的设置也需要在此对话框中进行,下面简要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmkjAz.html" rel="bookmark" class="title">一个简单的程序项目</a>
					<div>
						问题描述 题目:定义汽车人Autobots(擎天主代表,可以变成大卡车,在构造函数中完成初始化)定义霸天虎Decepticons(威震天为代表,可以变成枪,在构造函数中完成初始化)特征:故乡,名字,对 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
